program bump_fp;

uses arb_fragment_program;

param
 LightSize,LightColor,LightSpecular:vec4;
varying
 texcoord,LightVec,LightVec2,ViewVec:vec4;
var
 color,halfvec,specular,bump:vec4;
begin
bump:=NormalMap(0,texcoord);
color:=sat(dot3(bump,normalize(LightVec)))*Texture2D(1,texcoord)*LightColor;
halfvec:=normalize(LightVec+ViewVec);
specular:=power(sat(dot(halfvec,bump)),8)*LightSpecular*Texture2D(2,texcoord);
result.color:=(color+specular)*lightatten(LightVec2,LightSize)*bump.w;
end;
