program volumelight_fp;

uses arb_fragment_program;

param
 LightViewPos,LightVolumeColor,LightSize:vec4;
varying
 FragmentPos:vec4;
var
 v1,v2,p:vec4;
begin
v1:=dot(FragmentPos,FragmentPos);
v2:=dot(FragmentPos,LightViewPos);
p:=sat(v2.x/v1.x)*FragmentPos-LightViewPos;
p:=p*LightSize;
v1:=sat(1-dot(p,p));
result.color:=LightVolumeColor*sqr(v1*v1*v1*v1);
end;
