program bump_vp;

uses arb_vertex_program;

param
 LightPos,CamPos:vec4;
varying
 texcoord,LightVec,LightVec2,ViewVec:vec4;
var
 lv:vec4;
begin
result.position:=MatrixMult4(state.matrix.mvp,vertex.position);
result.color:=vertex.color;
texcoord:=vertex.attrib[8];
lv:=LightPos-vertex.position;
LightVec:=MatrixMult3(Matrix(vertex.attrib[6],cross(vertex.attrib[6],vertex.attrib[2]),vertex.attrib[2]),lv);
LightVec2:=lv;
lv:=CamPos-vertex.position;
ViewVec:=MatrixMult3(Matrix(vertex.attrib[6],cross(vertex.attrib[6],vertex.attrib[2]),vertex.attrib[2]),lv);
end;
